require(GlobalDependencys:GetDependency("StandardBase"):GetPackageName())

--GAME VARS
fDefaultFOV = 85
fAdditionalFOV = 0
fAspectRatio = DisplayInfo:GetWidth() / DisplayInfo:GetHeight()
fAspectRatio169 = 1.777777791
fFactor = 0.00872665
fHUDSafeZOneLeft = 0
fHUDSafeZoneRight = 0

--ControlVars
bFixEnabled = true
bFOV = true
bAspect = true
bHUDSafeZone = true
bFPS = true
bFringe = true
bDOF = true

--PROCESS VARS
Process_FriendlyName = Module:GetFriendlyName()
Process_WindowName = "*"
Process_ClassName = "UnrealWindow"
Process_EXEName = "Cigars-Win64-Shipping.exe"

--INJECTION BEHAVIOUR
InjectDelay = 500
WriteInterval = 100
SearchInterval = 100
SuspendThread = true

--Name                         Manual/Auto/Hybrid  		Steam/Origin/Any                IncludeFile:Configure;Enable;Periodic;Disable;
SupportedVersions = { 		
{"Automatically Detect",       "Hybrid",  			"Any",	                         "Configure_SignatureScan;Enable_Inject;Periodic;Disable_Inject;"},
}

function Init_Controls()

	DefaultControls.AddHeader("Header_FixesEnableDisable","Individual Fixes",245,70,210,17)
	
	DefaultControls.AddHeader("Header_FOV","FOV fine adjustment",15,70,210,17)	
	DefaultControls.AddFixedFOVSlider("FOVSlider","FOVSlider_Changed",55,100,125,35,0,120,0,1)
	FOVSlider:SetTickFrequency(10)
	FOVSlider:SetLabel1Text("-20")
	FOVSlider:SetLabel2Text("+100")
	
	DefaultControls.AddHeader("HeaderHUDSZ","HUD safe zone",15,160,210,17)	
	DefaultControls.AddFixedFOVSlider("HUD","HUDSZSlider_Changed",55,190,125,35,0,40,0,1)
	HUD:SetTickFrequency(5)
	HUD:SetLabel1Text("0")
	HUD:SetLabel2Text("40")

	DefaultControls.AddFixToggle("CKFOVFix_Enable","FOV fix","CKFOVFix_Changed",255,101,180,14)
	DefaultControls.AddFixToggle("CKHUDFix_Enable","HUD safe zone fix","CKHUDFix_Changed",255,121,180,14)
	DefaultControls.AddFixToggle("CKFPSFix_Enable","FPS fix","CKFPSFix_Changed",255,141,180,14)
	DefaultControls.AddFixToggle("CKFRINGEFix_Enable","Chromatic aberration fix","CKFRINGEFix_Changed",255,161,180,14)
	DefaultControls.AddFixToggle("CKDOFFix_Enable","Depth of field fix","CKDOFFix_Changed",255,181,180,14)
	
end

function Configure_SignatureScan() 
	
	local tAddress = HackTool:AddAddress("FOV")
	
	if HackTool:SignatureScan("0F ?? ?? 48 8B ?? ?? ?? ?? ?? ?? 48 ?? ?? E8 ?? ?? ?? ?? 0F 28 ?? ?? ?? ?? ?? ?? 48 81 ?? ?? ?? ?? ?? C3",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Cigars-Win64-Shipping.APlayerCameraManager::GetFOVAngle+5D - 74 05                 	- je Cigars-Win64-Shipping.APlayerCameraManager::GetFOVAngle+64
		--Cigars-Win64-Shipping.APlayerCameraManager::GetFOVAngle+5F - E8 BC D9 3A FE           - call Cigars-Win64-Shipping.FMemory::Free
		--Cigars-Win64-Shipping.APlayerCameraManager::GetFOVAngle+64 - 0F 28 C6               	- movaps xmm0,xmm6
		--Cigars-Win64-Shipping.APlayerCameraManager::GetFOVAngle+67 - 48 8B 8C 24 20 06 00 00  - mov rcx,[rsp+00000620]
		--Cigars-Win64-Shipping.APlayerCameraManager::GetFOVAngle+6F - 48 33 CC              	- xor rcx,rsp
	end

	local tAddress = HackTool:AddAddress("HUDSAFEZONE")
	
	if HackTool:SignatureScan("48 ?? ?? 48 ?? ?? 66 48 ?? ?? ?? FF ?? 48 8B ?? ?? ?? 0F ?? ??",tAddress,PAGE_EXECUTE_READ,0x12,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+32DA69A - FF D0                 - call rax
		--O2-Win64-Shipping.exe+32DA69C - 48 8B 5C 24 40        - mov rbx,[rsp+40]
		--O2-Win64-Shipping.exe+32DA6A1 - 0F 10 00              - movups xmm0,[rax]
		--O2-Win64-Shipping.exe+32DA6A4 - 48 8B C7              - mov rax,rdi
		--O2-Win64-Shipping.exe+32DA6A7 - 0F 11 07              - movups [rdi],xmm0
	end
	
	local tAddress = HackTool:AddAddress("FPS")
	
	if HackTool:SignatureScan("F3 0F ?? ?? ?? EB ?? 0F ?? ?? 48 8B ?? ?? ?? 0F 28",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Cigars-Win64-Shipping.UEngine::GetMaxTickRate+1F4 - 3B 05 5E 81 08 02      - cmp eax,[Cigars-Win64-Shipping.GGameThreadId]
		--Cigars-Win64-Shipping.UEngine::GetMaxTickRate+1FA - 0F 95 C3               - setne bl
		--Cigars-Win64-Shipping.UEngine::GetMaxTickRate+1FD - F3 0F 10 04 9F         - movss xmm0,[rdi+rbx*4]
		--Cigars-Win64-Shipping.UEngine::GetMaxTickRate+202 - EB 03                  - jmp Cigars-Win64-Shipping.UEngine::GetMaxTickRate+207
		--Cigars-Win64-Shipping.UEngine::GetMaxTickRate+204 - 0F 28 C6               - movaps xmm0,xmm6
	end
		
	local tAddress = HackTool:AddAddress("FRINGE")
	
	if HackTool:SignatureScan("7F ?? 89 B3 ?? ?? ?? ?? 8B ?? ?? 39 05",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Cigars-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+7A - 48 8B 05 77 07 36 02  - mov rax,[Cigars-Win64-Shipping.exe+5A72978]
		--Cigars-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+81 - 39 30                 - cmp [rax],esi
		--Cigars-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+83 - 7F 06                 - jg Cigars-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+8B
		--Cigars-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+85 - 89 B3 84 10 00 00     - mov [rbx+00001084],esi
		--Cigars-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+8B - 8B 04 2F              - mov eax,[rdi+rbp]
	end

	local tAddress = HackTool:AddAddress("DOF")
	
	if HackTool:SignatureScan("8B ?? ?? E8 ?? ?? ?? ?? 8B ?? E8 ?? ?? ?? ?? 84 ?? 74 ?? 48",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Cigars-Win64-Shipping.DiaphragmDOF::IsEnabled+30 - 48 8B 05 81 E4 71 03  - mov rax,[Cigars-Win64-Shipping.exe+59BC6E8]
		--Cigars-Win64-Shipping.DiaphragmDOF::IsEnabled+37 - 48 8B CB              - mov rcx,rbx
		--Cigars-Win64-Shipping.DiaphragmDOF::IsEnabled+3A - 8B 78 04              - mov edi,[rax+04]
		--Cigars-Win64-Shipping.DiaphragmDOF::IsEnabled+3D - E8 CE 7E 47 01        - call Cigars-Win64-Shipping.FSceneView::GetShaderPlatform
		--Cigars-Win64-Shipping.DiaphragmDOF::IsEnabled+42 - 8B C8                 - mov ecx,eax
	end
	
	return true
end

function Enable_Inject()

	local Variables = HackTool:AllocateMemory("Variables",0)
	Variables:PushFloat("CompensatedFOV")
	Variables:PushFloat("FOVIn")
	Variables:PushFloat("FOVOut")
	Variables:PushFloat("AdditionalFOV")
	Variables:PushFloat("AspectRatio")
	Variables:PushFloat("ScreenRatio")
	Variables:PushFloat("factor")
	Variables:PushFloat("HUDSafeZoneLeft")
	Variables:PushFloat("HUDSafeZoneTop")
	Variables:PushFloat("HUDSafeZoneRight")
	Variables:PushFloat("HUDSafeZoneBottom")
	Variables:PushFloat("HUDSafeZoneDefRight")
	Variables:PushFloat("HUDSafeZoneDefBottom")
	Variables:Allocate()
	Variables["FOVIn"]:WriteFloat(fDefaultFOV)
	Variables["FOVOut"]:WriteFloat(fDefaultFOV)
	Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
	Variables["AspectRatio"]:WriteFloat(fAspectRatio169)
	Variables["ScreenRatio"]:WriteFloat(fAspectRatio)
	Variables["factor"]:WriteFloat(fFactor)
	Variables["HUDSafeZoneLeft"]:WriteFloat(0)
	Variables["HUDSafeZoneTop"]:WriteFloat(0)
	Variables["HUDSafeZoneRight"]:WriteFloat(1)
	Variables["HUDSafeZoneBottom"]:WriteFloat(1)
	Variables["HUDSafeZoneDefRight"]:WriteFloat(1)
	Variables["HUDSafeZoneDefBottom"]:WriteFloat(1)
	
	ResolutionChanged()	
	
	local asm = [[	

		(codecave:jmp)FOV,FOV_cc:
			movss [(allocation)Variables->FOVIn],$$2						$ctx=1
			fld dword ptr [(allocation)Variables->FOVIn]
			fmul dword ptr [(allocation)Variables->factor]
			fptan
			fstp st0
			fld dword ptr [(allocation)Variables->ScreenRatio]
			fdiv dword ptr [(allocation)Variables->AspectRatio]
			fmulp st1,st0
		    fld1
		    fpatan
			fdiv dword ptr [(allocation)Variables->factor]						; calculate compensated FOV
			fstp dword ptr [(allocation)Variables->CompensatedFOV]				; and retrieve it			
			movss $$2,[(allocation)Variables->CompensatedFOV]				$ctx=1
			addss $$2,[(allocation)Variables->AdditionalFOV]				$ctx=1
			movss [(allocation)Variables->FOVOut],$$2						$ctx=1
			%originalcode%
			jmp %returnaddress%
			%end%

		(codecave:jmp)HUDSAFEZONE,HUDSAFEZONE_cc:
			movsd xmm14,[$$2+8]												$ctx=1
			ucomisd xmm14,[(allocation)Variables->HUDSafeZoneDefRight]
			jne next			
			$$0 xmm14,[(allocation)Variables->HUDSafeZoneLeft]				$ctx=1
			$$0 [$$2],xmm14													$ctx=1
			
			next:
			%originalcode%			
			jmp %returnaddress%
			%end%
			
		(codecave:jmp)FPS,FPS_cc:
			$$0 $$1,[noLimit]												$ctx=1
			jmp %returnaddress%
			%end%
			
		noLimit: (float)0

		(codecave)FRINGE,FRINGE_cc:
			nop
			nop
			%end%
			
		(codecave)DOF,DOF_cc:
			xor $$1,$$1														$ctx=1
			nop
			%end%
			
	]]

	if HackTool:CompileAssembly(asm,"Fixes") == nil then
		return ErrorOccurred("Assembly compilation failed...")
	else
		Toggle_CodeCave("FOV_cc",bFOV)
		Toggle_CodeCave("HUDSAFEZONE_cc",bHUDSafeZone)
		Toggle_CodeCave("FPS_cc",bFPS)
		Toggle_CodeCave("FRINGE_cc",bFringe)
		Toggle_CodeCave("DOF_cc",bDOF)
	end	
			
	Write_FOV()
	Write_HUD_Safe_Zone()
	
end

function Periodic()

	local Variables = HackTool:GetAllocation("Variables")
	
	if Variables and Variables["FOVIn"] and Variables["AdditionalFOV"] then
		local fCompensatedFOV = Variables["CompensatedFOV"]:ReadFloat()
		local fFOVIn = Variables["FOVIn"]:ReadFloat()
		local fFOVOut = Variables["FOVOut"]:ReadFloat()
		PluginViewport:AppendStatusMessage( string.format("\r\n===== Fix informations =====\r\nFOV In: %.2f, Compensated FOV: %.2f, FOV Out: %.2f", fFOVIn, fCompensatedFOV, fFOVOut))
	end
	
end

function FOVSlider_Changed(Sender)

	fAdditionalFOV = Sender:GetPosition() - 20
	lblFOVSlider.Caption:SetCaption( string.format("Value: +%.0f",fAdditionalFOV) )		
	Write_FOV()
	ForceUpdate()

end

function Write_FOV()

	local Variables = HackTool:GetAllocation("Variables")
	if Variables and Variables["AdditionalFOV"] then
		if bFOV == true then
			Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
		else
			Variables["AdditionalFOV"]:WriteFloat(0)
		end
	end

end

function Write_HUD_Safe_Zone()

	local Variables = HackTool:GetAllocation("Variables")
	
	if Variables and Variables["HUDSafeZoneLeft"] and Variables["HUDSafeZoneRight"] then
		Variables["HUDSafeZoneLeft"]:WriteFloat(fHUDSafeZOneLeft / 100)
		Variables["HUDSafeZoneRight"]:WriteFloat(1 - (fHUDSafeZoneRight / 100))
	end
	
end

function Disable_Inject()
	
	CleanUp()
	
end

function CKFOVFix_Changed(Sender)

	bFOV = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FOV_cc",bFOV)
	Write_FOV()
	ForceUpdate()
	
end

function CKHUDFix_Changed(Sender)

	bHUDSafeZone = Toggle_CheckFix(Sender)
	Toggle_CodeCave("HUDSAFEZONE_cc",bHUDSafeZone)
	ForceUpdate()

end

function CKFPSFix_Changed(Sender)

	bFPS = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FPS_cc",bFPS)
	ForceUpdate()

end

function CKFRINGEFix_Changed(Sender)

	bFringe = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FRINGE_cc",bFringe)
	ForceUpdate()

end

function CKDOFFix_Changed(Sender)

	bDOF = Toggle_CheckFix(Sender)
	Toggle_CodeCave("DOF_cc",bDOF)
	ForceUpdate()

end

function HUDSZSlider_Changed(Sender)

	fHUDSafeZOneLeft = Sender:GetPosition()
	fHUDSafeZoneRight = fHUDSafeZOneLeft
	lblHUD.Caption:SetCaption( string.format("+ %.0f %%",fHUDSafeZOneLeft) )
	Write_HUD_Safe_Zone()
	ForceUpdate()
	
end

function ResolutionChanged() 

	SyncDisplayDetection()
	
end

function Init()

	Init_BaseControls()
	Init_Controls()

end

function DeInit()

	DisableFix()

end
